/*
 *  Soccer Client Program basic routines
 *    Ogalets the fourth
 *      presented by Ogawara
 */
#include "oga5a.h"

Socket init_connection(char* host, int port) ;
int    send_message(char* buf, Socket sock) ;
int    receive_message(char *buf, int size, Socket *sock) ;
void   close_connection(Socket sock) ;

Socket sock ;
double mx,my,mdir;
double bx,by,ob_dist=0;
int  player;
char side,cir_flag=0;
int  play_mode=0,time_counter=0;
int  mp_num,op_num; /* mp_num...number of my team in sight,
		       op_num...that of opponent team */
char team_name[]="Ogalets";
double flag_posi[12][2]={{0.0,-34.0},{0.0,34.0}
			 ,{-52.5,-34.0},{-52.5,34.0},{-36.0,0.0},{-36.0,-20.0},{-36.0,20.0}
			 ,{ 52.5,-34.0},{ 52.5,34.0},{ 36.0,0.0},{ 36.0,-20.0},{ 36.0,20.0}};
double goal_posi[2][2]={{-52.5,0},{52.5,0}};
int  init_posi[11][10]={{-50,0},{-1,0},{-1,3},{-1,-30},{-1,30},{-15,0},{-40,-25},{-40,25},{-30,0},
			{-35,-15},{-35,15}};
double off_posi[11][2]={{-50,0},{42,-8},{40,8},{25,-30},{25,30},{10,0},{-10,-25},{-10,25},{-20,0},
			    {-35,-10},{-35,10}};
double area_posi[11][2]={{20,15},{15,15},{20,15},{30,20},{30,20},{20,25},{20,15},{20,15},{20,25},
			     {20,25},{20,25}};

struct relative_address ball,flag[12],goal[2],line[4],mplayer[11],oplayer[11];
struct sequence_list s_list;

double get_angle(double dx,double dy){
    double dist=sqrt(dx*dx+dy*dy);
    double a,b,dir;

    dx/=dist;
    dy/=dist;
    a=asin(dy);
    b=acos(dx);
    dir=b*180.0/PI;
    if (a<0)
	dir=360-dir;
    return dir;
}
	
int  get_my_posi(void){ /* get my position from the sight information */
    int  lnum=0,ls[2],phase;
    int  i,j,cond_flag=0;
    double dist,px,py,lx,ly,dir,ldir;

    for (i=0;i<4;i++)
	if (line[i].count==time_counter)
	    ls[lnum++]=i;
    if (lnum==2)
	if (line[ls[0]].d[0]>line[ls[1]].d[0])
	    phase=0;
	else
	    phase=1;
    if (lnum==0) /* out of the field and no lines in sight */
	return -1;

    for (j=0;j<lnum;j++){
	i=ls[j];
	dist=line[i].d[0]*cos(line[i].d[1]*PI/180.0);
	switch(i){
	  case 0: /* left end */
	    if ((lnum==1) || (phase==j)){
		lx=-52.5+dist;
		ldir=line[i].d[1]+180.0;
	    } else{
		lx=-52.5-dist;
		ldir=line[i].d[1]+0.0;
	    }
	    cond_flag|=0x01;
	    break;
	  case 1: /* right end */
	    if ((lnum==1) || (phase==j)){
		lx=52.5-dist;
		ldir=line[i].d[1]+0.0;
	    } else{
		lx=52.5+dist;
		ldir=line[i].d[1]+180.0;
	    }
	    cond_flag|=0x01;
	    break;
	  case 2: /* top end */
	    if ((lnum==1) || (phase==j)){
		ly=-34.0+dist;
		ldir=line[i].d[1]+270.0;
	    } else{
		ly=-34.0-dist;
		ldir=line[i].d[1]+90.0;
	    }
	    cond_flag|=0x02;
	    break;
	  case 3: /* bottom end */
	    if ((lnum==1) || (phase==j)){
		ly=34.0-dist;
		ldir=line[i].d[1]+90.0;
	    } else{
		ly=34.0+dist;
		ldir=line[i].d[1]+270.0;
	    }
	    cond_flag|=0x02;
	    break;
	}
    }
    if (cond_flag!=0x03){
	dist=180.0;
	for (i=0;i<12;i++){
	    if ((flag[i].count==time_counter) &&
		(dist>flag[i].d[0])){
		dist=flag[i].d[0];
		dir=flag[i].d[1];
		px=flag_posi[i][0];
		py=flag_posi[i][1];
	    }
	}
	for (i=0;i<2;i++){
	    if ((goal[i].count==time_counter) &&
		(dist>goal[i].d[0])){
		dist=goal[i].d[0];
		dir=goal[i].d[1];
		px=goal_posi[i][0];
		py=goal_posi[i][1];
	    }
	}
	if (player==19)
	    if (dist==180.0)
		printf("px --- py --- dir %lf ldir %lf\n",dir,ldir);
	    else
		printf("px %lf py %lf dir %lf ldir %lf\n",px,py,dir,ldir);
	if (cond_flag==0x01){
	    mx=lx;
	    if (dist!=180.0)
		my=py-dist*sin((ldir+dir)*PI/180.0);
	} else{
	    my=ly;
	    if (dist!=180.0)
		mx=px-dist*cos((ldir+dir)*PI/180.0);
	}
    } else{
	mx=lx;
	my=ly;
    }
    mdir=ldir;
    if (player==19)
	printf("my posi=(%lf,%lf) dir=%lf\n",mx,my,mdir);
    return 0;
}
				
void kick(int pow,double dir){
    char mes[50];
	
    if (pow<0)
	pow=0;
    else if (pow>100)
	pow=100;
    if (dir<-180.0)
	dir+=360.0;
    else if (dir>180.0)
	dir-=360.0;
    sprintf(mes,"(kick %d %d)\n",pow,(int)dir);
    send_message(mes,sock);
}
	
void dash(int pow){
    char mes[50];
    
    if (pow>100)
	pow=100;
    else if (pow<-30)
	pow=-30;
    sprintf(mes,"(dash %d)\n",pow);
    send_message(mes,sock);
}
	
void turn(double angle){
    char mes[50];
	
    if (angle<-180.0)
	angle+=360.0;
    else if (angle>180.0)
	angle-=360.0;
    sprintf(mes,"(turn %d)\n",(int)angle);
    send_message(mes,sock);
}
	
/*  buf...dist dir dist_chg dir_chg */
char *get_para(struct relative_address *st,char *buf){
    double d;
    int  i=0,m_flag;
    
    st->count=time_counter;
    
    while(1){
	d=0.0; m_flag=0;
	while((*buf!=')') && (*buf!=' ')){
	    if (*buf=='.'){
		buf++;
		d+=(double)(*buf-'0')/10.0;
	    } else if (*buf=='-')
		m_flag=1;
	    else
		d=d*10.0+(double)(*buf-'0');
	    buf++;
	}
	if (d==180.0) /* ????? */
	    d=0.0;
	if (m_flag)
	    d=-d;
	st->d[i++]=d;
	if (*buf==')'){
	    while (i<4)
		st->d[i++]=-360.0;
	    st->dist=st->d[0];
	    st->dir=(int)st->d[1];
	    st->vdir=0;
	    return (buf+1);
	} else
	    buf++;
    }	
}
	
int init_condition(char *name){	/* -1...error */
    char buf[MAXMESG],info[3][20];
    int  i,count,i_count;
    char init_mes1[30],mov_mes1[30];

    sprintf(init_mes1,"(init %s)\n",name);
    send_message(init_mes1,sock);
    while (receive_message(buf, MAXMESG, &sock)<=0) ;

    if (buf[1]=='e'){
	printf("initialize error\n");
	return -1;
    }
    
    count=6;
    for (i=0;i<3;i++){
	i_count=0;
	while ((buf[count]!=' ') && (buf[count]!=')'))
	    info[i][i_count++]=buf[count++];
	count++;
	info[i][i_count]=0;
    }
    if (strcmp("before_kick_off",info[2])!=0){
	printf("match is on play\n");
	return -1;
    }
    player=atoi((char *)info[1])-1;
    side=info[0][0];
    mx=(double)init_posi[player][0];
    my=(double)init_posi[player][1];
    s_list.count=0;
    sprintf(mov_mes1,"(move %d %d)\n",init_posi[player][0],init_posi[player][1]);
    usleep(100000);
    send_message(mov_mes1,sock);
    usleep(100000);
    send_message("(change_view narrow high)\n",sock);
    bx=0; by=0;

    while(1){
	while (receive_message(buf, MAXMESG, &sock)<=0) ;
	if (buf[1]=='h'){
	    if (hear(buf)==1){
		return 0;
	    }
	}
    }
}

	
/*
 * UDP connection γ
 *
 *  :
 * host : host name ⤷ host  IP address
 * port : port ֹ
 * 
 *  :
 * error ȯ硢Socket.socketfd  -1 ֤
 * 
 */
 
Socket init_connection(char *host, int port)
{
    struct hostent 	*host_ent ;
    struct in_addr      *addr_ptr ;
    struct sockaddr_in	cli_addr ;
    int			sockfd, val ;
    Socket		sock ;

    sock.socketfd = -1 ;

    if((host_ent = (struct hostent *)gethostbyname(host)) == NULL) {
	/* Check if a numeric address */
	if(inet_addr(host) == -1){
	    return sock ;
	}
    }
    else{
	addr_ptr = (struct in_addr *) *host_ent->h_addr_list ;
	host = inet_ntoa(*addr_ptr) ;
    }


    /*
     *  Open UDP socket.
     */
    if( (sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0){
	return sock ;  	/* Can't open socket. */
    }

    val = fcntl(sockfd, F_GETFL, 0) ;
    val |= O_NONBLOCK ;
    fcntl(sockfd, F_SETFL, val) ;

    /*
     *  Bind any local address.
     */
    bzero((char *) &cli_addr, sizeof(cli_addr)) ;
    cli_addr.sin_family		= AF_INET ;
    cli_addr.sin_addr.s_addr	= htonl(INADDR_ANY) ;
    cli_addr.sin_port		= htons(0) ;


    if(bind(sockfd, (struct sockaddr *) &cli_addr,
	    sizeof(cli_addr)) < 0){
	return sock ;  /* Can't bind local address */
    }
    

    /*
     *  Fill in the structure with the address of the server.
     */
    sock.socketfd = sockfd ;

    bzero((char *) &sock.serv_addr, sizeof(sock.serv_addr)) ;
    sock.serv_addr.sin_family		= AF_INET ;
    sock.serv_addr.sin_addr.s_addr	= inet_addr(host) ;
    sock.serv_addr.sin_port		= htons(port) ;

    return sock ;
}


/*
 * socket  message 
 *
 *  :
 * buf  : message 
 * sock : socket
 * 
 *  :
 * Ф˼Ԥ硢-1 ֤
 * 
 */

int send_message(char *buf, Socket sock)
{
    int n ;

    n = strlen(buf) ;
/*    printf( "send %d : %s\n",
	ntohs(sock.serv_addr.sin_port),buf);*/
    if( sendto(sock.socketfd, buf, n, 0,
	        (struct sockaddr *)&sock.serv_addr, sizeof(sock.serv_addr))
	  != n )
	return (-1) ;
    else
	return 0 ;
}
	   
/*
 * socket  message μ
 *
 *  :
 * buf  : message  buffer
 * size : sizeof(buf)
 * sock : socket
 * 
 *  :
 * ˼Ԥ硢-1 ֤
 * Ƥ̵硢 0 ֤
 * Ƥ硢 1 ֤
 * 
 */

int receive_message(char *buf, int size, Socket *sock)
{
    int			n,servlen ;
    struct sockaddr_in	serv_addr ;
    
    servlen = sizeof(serv_addr) ;
    n = recvfrom(sock->socketfd, buf, size, 0,
			 (struct sockaddr *)&serv_addr, &servlen);

    if(n < 0)
	if( n == -1 && errno == EWOULDBLOCK){
	    buf[0] = '\0' ;
	    return 0 ;
	}
	else
	    return (-1) ;
    else{
/*	printf( "recv %d : ", ntohs(serv_addr.sin_port));*/
	sock->serv_addr.sin_port = serv_addr.sin_port ;
	buf[n] = '\0' ;

	if(n == 0)
	    return 0 ;
	else
	    return 1 ;
    }
}



/*
 * socket  close
 *
 *  :
 * sock : socket
 * 
 */

void close_connection(Socket sock)
{
    close(sock.socketfd) ;
}
